"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeatureToggleActionMiddlewareInterceptor = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const rest_1 = require("@loopback/rest");
const keys_1 = require("../keys");
let FeatureToggleActionMiddlewareInterceptor = class FeatureToggleActionMiddlewareInterceptor {
    constructor(checkFeatureFlag) {
        this.checkFeatureFlag = checkFeatureFlag;
    }
    value() {
        return this.intercept.bind(this);
    }
    async intercept(context, next) {
        const featureFlagEnabled = await this.checkFeatureFlag();
        if (!featureFlagEnabled) {
            throw new rest_1.HttpErrors.Forbidden('This particular feature is not accessible to you');
        }
        return next();
    }
};
FeatureToggleActionMiddlewareInterceptor = tslib_1.__decorate([
    (0, core_1.globalInterceptor)(),
    tslib_1.__param(0, (0, core_1.inject)(keys_1.StrategyBindings.FEATURE_FLAG_ACTION)),
    tslib_1.__metadata("design:paramtypes", [Function])
], FeatureToggleActionMiddlewareInterceptor);
exports.FeatureToggleActionMiddlewareInterceptor = FeatureToggleActionMiddlewareInterceptor;
//# sourceMappingURL=feature-toggle-action.middleware.js.map